import Compiler from "../Compiler/Compiler.js"
import printDebug from "./DebugPrint.js"
import { getDefaultCompiler, setDefaultCompiler } from "./DefaultCompiler.js"

const setGetDefaultCompiler = (name: string, newCompiler: { (): Compiler }) => {
    let defaultCompiler = getDefaultCompiler("g++")
    if (defaultCompiler) {
        return defaultCompiler
    } else {
        printDebug(`setting default compiler for g++`)
        setDefaultCompiler("g++", newCompiler())
        defaultCompiler = getDefaultCompiler("g++")
        if (defaultCompiler) {
            return defaultCompiler
        } else {
            throw Error("cannot set compiler")
        }
    }
}

export default setGetDefaultCompiler