import path from "path";
import printDebug from "./Tools/DebugPrint.js";
import { existsSync } from "fs";
import printErrorOrDebug from "./Tools/PrintErrorOrDebug.js";
import { setNmakePath } from "./Tools/NmakePath.js";
import CppBuilder from "./Builder/CppBuilder.js";

// const argv = require('minimist')(process.argv.slice(2))
import minimist from "minimist";
const argv = minimist(process.argv.slice(2))

let nmakeFileName = "nmake.js"
if(argv["v"])(global as any).isDebug=true
if (argv["f"]) {nmakeFileName = argv["f"];printDebug(`setting nmake file name to ${argv["f"]}`)}

const nmakeFilePath = path.join(process.cwd(),nmakeFileName)
printDebug(`file path is ${nmakeFilePath}`)


printDebug("finding nmake file at "+nmakeFilePath)
if(!existsSync(nmakeFilePath))printErrorOrDebug(`cannot find file ${nmakeFilePath}`)
printDebug("found nmake file")

setNmakePath(nmakeFilePath)

printDebug("adding ts-node")
// import ts_node from "ts-node" 
import { pathToFileURL } from "url";
// ts_node.register()

printDebug("adding global values")

console.log("running nmake file "+nmakeFilePath)
printDebug(`running file ${nmakeFilePath}`)
// require(nmakeFilePath)

await import(pathToFileURL(nmakeFilePath).toString())
printDebug(`run completion!`,nmakeFilePath)

if(argv["b"]){
    printDebug("will build the project")
    await new CppBuilder().build()
}

// if (argv[0]) {
//     switch (argv[0]) {
//         case "b":
            
//             break;
    
//         default:
//             break;
//     }
// }